#include "objects.h"

float idmat[4][4] = 
{
    1.0, 0.0, 0.0, 0.0,
    0.0, 1.0, 0.0, 0.0,
    0.0, 0.0, 1.0, 0.0,
    0.0, 0.0, 0.0, 1.0
  };

 float black[3] = { 0., 0., 0. };
 float lblack[3] = {.07, .09, 0. };
 float blue[3] = { 0., 0., 1. };
 float lblue[3] = {.6, .7, 1.};
 float yellow[3] = {.615, .615, 0.};
 float pink[3] = {1., 0., .4};
 float lgreen[3] = {.611, 0.851, .514};
 float gray[3] = {.5, .5, .5};
/* float red[3] = {0.443, 0.051, 0.169};*/
 float red[3] = {.79,0.,.09};
 float redn[3] = {1., 0.0, 0.0};
 float green[3] = {0., 1., .00};
 float orange[3] = {1., .5, 0.};
 float white[3] = {1., 1., 1.};
 float brown[3] = {.49, .247, .133};



float mat_rol[] =
	{ SPECULAR, .4, .4, .4,
	  DIFFUSE,  .545, 0.467, 0.0,
	  SHININESS, 30.,
          ALPHA, 1.,
	  LMNULL};

float mat_fol[] =
	{ SPECULAR, .4, .4, .4,
	  DIFFUSE,  .572, 0.149, 0.07,
	  SHININESS, 30.,
          ALPHA, 1.,
	  LMNULL};

float mat_pins[] =
	{ SPECULAR, 1., .835, .741,
	  DIFFUSE,  .2, .18, 0.2,
	  SHININESS, 60.,
          ALPHA, 1.,
	  LMNULL};

float mat_cam[] =
	{ /*SPECULAR, .462, .784, 1.,
	  DIFFUSE,  .749, .835, 0.855,*/
	  SPECULAR, 1., 1., 1.,
	  DIFFUSE,  .59, .55, 0.59,
	  SHININESS, 60.,
          ALPHA, 1.,
	  LMNULL};

float mat_frame[] =
	{ SPECULAR,.0, .154, .392,
          DIFFUSE,  .129, .08, 1.,
	  AMBIENT,  0.0, 0.102, 0.16,
	  SHININESS, 20.,
          ALPHA, 1.,
	  LMNULL};

float mat_sphere[] =
	{ 
	 ALPHA ,           .3, 
         AMBIENT,          0.2, 0.2, 0.2, 
         COLORINDEXES,     0.0, 127.5, 255.0, 
         DIFFUSE,          0.8, 0.8, 0.8, 
         EMISSION ,        0.0, 0.0, 1.0, 
         SHININESS,        40.0, 
         SPECULAR,         1.0, 0.0, 0.0,          
	 LMNULL};

float white3_light[] =
	{ /*LCOLOR, .9, .7, .5,*/
          LCOLOR, .886, .894, .5,
	  POSITION,  .36, .36, .9, 0.,
	  LMNULL};


float white4_light[] =
	{ LCOLOR, .8, .8, .8,
	  POSITION, -4., 0., 0., 0,
	  LMNULL};

float white5_light[] =
	{ LCOLOR, .5, .5, .5,
	  POSITION, 20., -2., .0, 1.,
	  LMNULL};


static float lm[] = {
  AMBIENT, 0.4,0.4,0.4,
  LOCALVIEWER, 1,
  LMNULL
};

static float lm2[] = {
  AMBIENT, .3,.3,.3,
  LOCALVIEWER, 1,
  LMNULL
};

static float lt[] = {
  LCOLOR, 1., .75, .75,
  POSITION, 0.,0.,3.,0,
  LMNULL
};

static float lt2[] = {
  LCOLOR, 1, .7, .7,
  POSITION, 0,0,1,0,
  LMNULL
};


/*---------------------------------------------------*/

void def_light_calc() {
	lmdef(DEFMATERIAL,C_PINS, 11, mat_pins);
	lmdef(DEFMATERIAL,C_FRAME, 11, mat_frame);
	lmdef(DEFMATERIAL,C_FOL, 11, mat_fol);
	lmdef(DEFMATERIAL,C_CAM, 11, mat_cam);
	lmdef(DEFMATERIAL,C_ROLLER, 11, mat_rol);
	lmdef(DEFMATERIAL,C_SPHERE, 11, mat_sphere);
	lmdef(DEFLIGHT, 3, 0, white3_light);
	lmdef(DEFLIGHT, 4, 10, white4_light);
	lmdef(DEFLIGHT, 5, 10, white5_light);
        lmdef(DEFLIGHT,1,0,lt);
        lmdef(DEFLIGHT,2,0,lt2);
        lmdef(DEFLMODEL,1,0,lm);
        lmdef(DEFLMODEL,2,0,lm2);
}

/*---------------------------------------------------*/

void use_light_calc()
{
/*	lmbind(LIGHT0, 4);*/
	lmbind(LIGHT0, 3);
}



/*---------------------------------------------------*/
