/* cs_3_ind_rr.c */

#include "head_usycams.h"
#include "def_usycams.h"
#include "objects.h"
#include "def_surfaces.h"

/*
double sc[6*POINTS+M][2][3],sf[6*POINTS+M][2][3]; 
double uc[6*POINTS+M][CPOINTS+1][3],uf[6*POINTS+M][CPOINTS+1][3]; 
double v_cam[6*POINTS+M][CPOINTS+1][3];
double v_fol[6*POINTS+M][CPOINTS+1][3];
float  nsc[6*POINTS+M][2][3],nsf[POINTS+M][2][3];
float  nuc[6*POINTS+M][CPOINTS+1][3],nuf[6*POINTS+M][CPOINTS+1][3];
float  nvc[6*POINTS+M][CPOINTS+1][3],nvf[6*POINTS+M][CPOINTS+1][3];
*/

cs_3_ind_rr(a,n,d,l)
int    n;
double a,d,l[2];
{
 double p, tet;
 double pc[3], dpc[3], ec[3], dec[3];
 double s[2][3], ns[2][3], u[M][3], nu[M][3], v[M][3], nv[M][3];
 double z;
 double num,de,pmax,thmax;
 int    i,j,k;
 Boolean CA;

 FILE *fp1, *fp2, *fp3, *fp4, *fp5, *fp6, *fp7, *fp8;

 z     = io[POINTS/2][2];
 num   = z*z+z*cos(a);
 de    = z*z+2*z*cos(a)+1;
 pmax  = num*d/de;
 thmax = z*sin(a)/(z*cos(a)+1.);
 
 for(i=0;i<=POINTS;i++)
  {
   CA = TRUE;
   calvar(a,d,io[i][0],io[i][2],io[i][3],&p,&tet,pc,dpc,ec,dec,CA);
   calcsurph(a,d,pmax,thmax,pc,dpc,ec,dec,io[i][0],l,p,tet,s,ns,u,nu,v,nv,CA); 
   CA = FALSE;

   for(j=0;j<2;j++)
     {
      for(k=0;k<3;k++)
        {
         sc[i][j][k]  = s[j][k];
         nsc[i][j][k] = ns[j][k];
        }
     }
/*printf("%d %f %f %f",i,s[0][0],s[0][1],s[0][2]);
printf("        %f %f %f\n",ns[0][0],ns[0][1],ns[0][2]);*/
   for(j=0;j<=CPOINTS;j++)
     {
      for(k=0;k<3;k++)
        {
         uc[i][j][k]  = u[j][k];
         nuc[i][j][k] = (float)nu[j][k];
         v_cam[i][j][k]  = v[j][k];
         nvc[i][j][k] = (float)nv[j][k];
        }
     }

   calvar(a,d,io[i][1],io[i][2],io[i][3],&p,&tet,pc,dpc,ec,dec,CA);
   calcsurph(a,d,pmax,thmax,pc,dpc,ec,dec,io[i][1],l,p,tet,s,ns,u,nu,v,nv,CA);
   for(j=0;j<2;j++)
     {
      for(k=0;k<3;k++)
        {
         sf[i][j][k]  = s[j][k];
         nsf[i][j][k] = ns[j][k];
        }
     }
   for(j=0;j<=CPOINTS;j++)
     {
      for(k=0;k<3;k++)
        {
         uf[i][j][k]  = u[j][k];
         nuf[i][j][k] = (float)nu[j][k];
         v_fol[i][j][k]  = v[j][k];
         nvf[i][j][k] = (float)nv[j][k];
        }
     }
  }
 draw_cam();
 draw_fol(n);
}

calcsurph(alpha,dist,pmax,thmax,p,dp,e,de,psi,l,q,tet,s,ns,u,nu,v,nv,ca)
double alpha,dist,pmax,thmax,p[3], dp[3], e[3], de[3];
double psi, l[2], q, tet;
double s[2][3], ns[2][3], u[M][3], v[M][3], nu[M][3], nv[M][3];
Boolean ca;
{
 double t[3], b[3], ut[3], vt[3], nut[3], eta;
 double vec[3], num[3], euv[3];
 double dot_prod(), mag_vec();
 double thmin,qmin,teto;
 double dphi,dphimin,dphimax,point,theta;

 int    i,j;

/*------------------------------------------------Contact surface */
 for(i=0;i<2;i++)
  {
   for(j=0;j<3;j++)
      s[i][j] = p[j] + l[i]*e[j];
                                  /* vec=dp+lde, num = vec X e */
   for(j=0;j<3;j++)
      vec[j] = dp[j] + l[i]*de[j];
   cross_prod(vec,e,num);
   for(j=0;j<3;j++)
     {
      if(mag_vec(num)>0.0001)
         ns[i][j] = num[j]/mag_vec(num);
      else
         ns[i][j] = 0.;
      if(ns[i][j]>1000) ns[i][j]=0.;
     }   
  }
/*---------------------------------------------------------------- */


/*------------------------------------------------ T & B surfaces  */
 dphimax=io[POINTS/2][2]; 
 qmin = -(dist-pmax);
 thmin= -(alpha-thmax);
 i=0;
 for(eta=0.; eta<=1.; eta=eta+1./CPOINTS)
  {
   euv[0] = 0;
   if(ca)
     {
      euv[1] = sin(eta*tet);
      euv[2] = cos(eta*tet);
      if(ABS(alpha)>0.00001 && ABS(dist)>0.00001)
        {
         dphi = tan(eta*tet)/(sin(alpha)-cos(alpha)*tan(eta*tet));
         point= (dphi*dphi+dphi*cos(alpha))/(dphi*dphi+2*dphi*cos(alpha)+1.)*dist;
         t[0] = point;
        }
      else 
         t[0] = eta*q;
     }   

   else
     {
      if(ABS(alpha)>0.00001 && ABS(dist)>0.00001)
        {
         teto = -(-tet-alpha);
         dphimin = tan(teto)/(sin(alpha)-cos(alpha)*tan(teto));
         dphi = eta*(dphimax-dphimin)+dphimin;
         theta= atan(dphi*sin(alpha)/(dphi*cos(alpha)+1));
         point= (dphi*dphi+dphi*cos(alpha))/(dphi*dphi+2*dphi*cos(alpha)+1.)*dist-dist;
         euv[1] = sin(theta-alpha);
         euv[2] = cos(theta-alpha);
         t[0] = point;
        }
      else 
        {
         t[0] = eta*q;
         euv[1] = 0;
         euv[2] = 1;
        }
     }

   t[1] = l[1]*euv[1];
   t[2] = l[1]*euv[2];
   rot_z(t,psi,ut);
   for(j=0;j<3;j++)
      u[i][j]=ut[j];

/*if(ca)
{
   if(ABS(alpha)>0.00001 && ABS(dist)>0.00001)
      b[0] = point;
   else 
      b[0] = eta*q;
}
else
{*/
   if(ABS(alpha)>0.00001 && ABS(dist)>0.00001)
     {
      b[0] = point;
     }
   else 
      b[0] = eta*q;
/*}*/
   b[1] = l[0]*euv[1];
   b[2] = l[0]*euv[2];   
   rot_z(b,psi,vt);
   for(j=0;j<3;j++)
      v[i][j]=vt[j];

   rot_z(euv,psi,nut);
   for(j=0;j<3;j++)
     {
      nu[i][j] =  nut[j];
      nv[i][j] = -nut[j];
     }
   i++;
  }
/*---------------------------------------------------------------- */
/*printf("\n\n");*/

}

calvar(a,d,psi,dphi,ddphi,pp,tetp,pc,dpc,ec,dec,ca)
double a,d,psi,dphi,ddphi,*pp,*tetp,pc[3],dpc[3],ec[3],dec[3];
Boolean ca;
{
 double num,de,dnu,dde,p,dp,tet,dtet;

   num    =  SQR(dphi) + dphi*cos(a);
   de     =  SQR(dphi) + 2*dphi*cos(a) + 1.;
   dnu    =  2*dphi*ddphi + ddphi*cos(a);
   dde    =  2*dphi*ddphi + 2*ddphi*cos(a);

   p      =  num*d/de;
   dp     =  (dnu*d - p*dde)/de;
   tet    =  atan(dphi*sin(a)/(dphi*cos(a)+1));
   dtet   =  ddphi*sin(a)/de;

   if(!ca)
     {
      p      =  p - d;
      tet    =  tet - a;
     } 
 
   *pp    = p;
   *tetp  = tet;

   pc[0]  =  p*cos(psi);
   pc[1]  =  p*sin(psi);
   pc[2]  =  0;

   dpc[0] = -p*sin(psi) + dp*cos(psi);
   dpc[1] =  p*cos(psi) + dp*sin(psi);
   dpc[2] =  0;

   ec[0]  = -sin(psi)*sin(tet);
   ec[1]  =  cos(psi)*sin(tet);
   ec[2]  =  cos(tet);

   dec[0] = -cos(psi)*sin(tet) - sin(psi)*cos(tet)*dtet;
   dec[1] = -sin(psi)*sin(tet) + cos(psi)*cos(tet)*dtet;
   dec[2] = -sin(tet)*dtet;

}

draw_cam()
{
 double v1[3],v2[3];
 float  n1[3],n2[3];
 int    i,j,k;


 makeobj(CAM);
	   lmbind(MATERIAL,C_CAM); /* steel */
   for (k=0; k<1; k++)
     {
      bgnqstrip();
      for (i=0; i<=POINTS; i++)      
       {
         for(j=0;j<3;j++)
           {
            v1[j]=sc[i][k][j];
            v2[j]=sc[i][k+1][j];
            n1[j]= nsc[i][k][j];
            n2[j]= nsc[i][k+1][j];
           }
         n3f(n2);
         v3d(v2);
         n3f(n1);
         v3d(v1);
       }
      endqstrip();
     }

   for(k=0;k<CPOINTS;k++)
     {
      bgnqstrip();
      for(i=POINTS;i>=0;i--)
       {
        for(j=0;j<3;j++)
          {
           v1[j] = uc[i][k][j];
           v2[j] = uc[i][k+1][j];
           n1[j] = nuc[i][k][j];
           n2[j] = nuc[i][k+1][j];
          }
        n3f(n2);
        v3d(v2);
        n3f(n1);
        v3d(v1);
       }
      endqstrip();
     }

   for(k=0;k<CPOINTS;k++)
     {
      bgnqstrip();
      for(i=0;i<=POINTS;i++)
       {
        for(j=0;j<3;j++)
          {
           v1[j] = v_cam[i][k][j];
           v2[j] = v_cam[i][k+1][j];
           n1[j] = nvc[i][k][j];
           n2[j] = nvc[i][k+1][j];
          }
        n3f(n2);
        v3d(v2);
        n3f(n1);
        v3d(v1);
       }
      endqstrip();
     }
 closeobj();
}

draw_fol(n)
int n;
{
 double v1[3],v2[3];
 float  n1[3],n2[3];
 int    i,j,k;


 makeobj(PFOL);
   for (k=0; k<1; k++)
     {
      bgnqstrip();
      for (i=POINTS; i>=0; i--)      
       {
         for(j=0;j<3;j++)
           {
            v1[j]=sf[i][k][j];
            v2[j]=sf[i][k+1][j];
            n1[j]= nsf[i][k][j];
            n2[j]= nsf[i][k+1][j];
           }
         n3f(n2);
         v3d(v2);
         n3f(n1);
         v3d(v1);
       }
      endqstrip();
     }

   for(k=0;k<CPOINTS;k++)
     {
      bgnqstrip();
      for(i=0;i<=POINTS;i++)
       {
        for(j=0;j<3;j++)
          {
           v1[j] = uf[i][k][j];
           v2[j] = uf[i][k+1][j];
           n1[j] = nuf[i][k][j];
           n2[j] = nuf[i][k+1][j];
          }
        n3f(n2);
        v3d(v2);
        n3f(n1);
        v3d(v1);
       }
      endqstrip();
     }

   for(k=0;k<CPOINTS;k++)
     {
      bgnqstrip();
      for(i=POINTS;i>=0;i--)
       {
        for(j=0;j<3;j++)
          {
           v1[j] = v_fol[i][k][j];
           v2[j] = v_fol[i][k+1][j];
           n1[j] = nvf[i][k][j];
           n2[j] = nvf[i][k+1][j];
          }
        n3f(n2);
        v3d(v2);
        n3f(n1);
        v3d(v1);
       }
      endqstrip();
     }
 closeobj();
 makeobj(FOL);
	   lmbind(MATERIAL,C_FOL);
   pushmatrix();
   callobj(PFOL);
   for(i=1;i<n;i++)
     {
      rotate((int)(3600./(double)(n)),'z');
      callobj(PFOL);
     }
   popmatrix();
 closeobj();
}
