/* io_function.c */

#include <math.h>

#define ABS(a) (a<0 ? -(a) : (a))
#define SQR(a) (a)*(a)
#define SGN(a) (a<0 ? -(1.) : (1.))
#define PI 3.1415926535


io_function(n,rise,retu,inva,iout)
double iout[200][5],inva[8]; /* inva -> dphi,phim,ps1,ps2,ps3,x-period */
int   rise[1],retu[1],n;
{
  double x,x1,dx1,a4;
  double psi1,psi2,psi3,psi4,dx;
  double tau[3];
  int    i;

  psi1 = inva[2]*inva[6];
  psi2 = inva[3]*inva[6];
  psi3 = inva[4]*inva[6];
  psi4 = (1.-inva[2]-inva[3]-inva[4])*inva[6];

/*printf("%f %f %f %f\n",psi1,psi2,psi3,psi4);*/
  a4 = psi4;
  dx = inva[6]/(double)(n);
 
  i=0;
  for(x=0.; x<=inva[6]*1.002; x=x+dx)
    {
      iout[i][0]=x;  
      if(x <= psi1)
	{
	  iout[i][1] = inva[1];
	  iout[i][2] = 0.;
	  iout[i][3] = 0.;
	}
      else if(x > psi1 && x<= psi1+psi2)
	{
	  x1       = (x-psi1)/psi2;
	  dx1      = 1./psi2;
	  select_io(rise[0],x1,tau);
	  iout[i][1] = inva[0]*tau[0]+inva[1];
	  iout[i][2] = inva[0]*dx1*tau[1];
	  iout[i][3] = inva[0]*dx1*dx1*tau[2];
/*printf("psi=%f phi=%f x=%f tau=%f\n",iout[i][0]*180/PI,iout[i][1],x1,tau[0]);*/
	}
      else if(x > (psi1+psi2) && x<= (psi1+psi2+psi3))
	{
	  iout[i][1] = inva[0]+inva[1];
	  iout[i][2] = 0.;
	  iout[i][3] = 0.;
	}
      else if(x > (psi1+psi2+psi3)) 
	{
	  x1       = 1. - (x-psi1-psi2-psi3)/a4;
	  dx1      = -1./a4;
	  select_io(retu[0],x1,tau);
	  iout[i][1] = inva[0]*tau[0]+inva[1];
	  iout[i][2] = inva[0]*dx1*tau[1];
	  iout[i][3] = inva[0]*dx1*dx1*tau[2];
	}
      i++;
    }
}

io_ind_fun(rise,phimi,phima,n,p,io)  /* R */
double phimi,phima,p,io[200][5];
int    n,rise[1];
{
  double ddds[200];
  double x,x1,dx1,a1,h;
  double dx;
  double tau[3];
  int    i;

  h  = phima;
  a1 = p;
  dx = p/(double)(n);
 
  i=0;
  for(x=0.; x<=p*1.01; x=x+dx)
    {
      io[i][0] = x;  
      x1       = x/a1;
      dx1      = 1./a1;
      select_io(rise[0],x1,tau);
      io[i][1] = h*tau[0]+phimi;
      io[i][2] = h*dx1*tau[1];
      io[i][3] = h*dx1*dx1*tau[2];
      i++;
    }
}


select_io(type,x,tau)
int type;
double tau[3],x;
{
  switch(type)
    {
    case 1:
      harmonic(x,tau);
      break;
    case 2:
      cycloidal(x,tau);
      break;
    case 3:
      poly345(x,tau);
      break;
    case 4:
      poly4567(x,tau);
      break;
    case 5:
      mod_trap(x,tau);
      break;
    }
}

harmonic(x,tau)
double x,tau[3];
{
  tau[0] = (1-cos(PI*x))/2;
  tau[1] = PI*sin(PI*x)/2;
  tau[2] = PI*PI*cos(PI*x)/2;
}

cycloidal(x,tau)
double x,tau[3];
{
  tau[0] = x-sin(2*PI*x)/2/PI;
  tau[1] = 1-cos(2*PI*x);
  tau[2] = 2*PI*sin(2*PI*x);
}

poly345(x,tau) 
double x,tau[3];
{
  tau[0] = x*x*x*(10-15*x+6*x*x);
  tau[1] = 30*SQR(x*(x-1));
  tau[2] = 60*x*(x-1)*(2*x-1);
}

poly4567(x,tau)
double x,tau[3];
{
  tau[0] = x*x*x*(35*x-84*x*x+70*x*x*x-20*x*x*x*x);
  tau[1] = 140*x*x*x*(1-3*x+3*x*x-1*x*x*x);
  tau[2] = 420*x*x*(1-4*x+5*x*x*-2*x*x*x);
}

mod_trap(x,tau)
double x,tau[3];
{
}

